import es, playerlib, popuplib, gamethread

admin_list = ['STEAM_0:1:8592283','STEAM_0:1:9675545']

info = es.AddonInfo()
info['name'] = "Admin Teleport"
info['basename'] = "admin_teleport"
info['version'] = "1.2"
info['author'] = "Undead"
info['url'] = "http://forums.mattie.info/cs/forums/viewtopic.php?p=257704"
info['description'] = "Advanced Teleport System"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

dict_teleport = {}

def load():
  if not es.exists('saycommand', '!teleport'):
    es.regsaycmd('!teleport', 'admin_teleport/teleport_cmd')
  teleport_menu = popuplib.easymenu('teleport_menu', '_popup_choice', teleport_menu_select)
  teleport_menu.settitle("Select Option")
  teleport_menu.addoption('1', "Teleport To Player")
  teleport_menu.addoption('2', "Teleport Player To Me")
  teleport_menu.addoption('3', "Save Spot for Teleport")
  teleport_menu.addoption('4', "Teleport To Saved Spot")
  teleport_menu.addoption('5', "Teleport Other To Saved Spot")
  teleport_menu.addoption('6', "Teleport A Player to Another")

def teleport_cmd():
  userid = es.getcmduserid()
  if es.getplayersteamid(userid) in admin_list:
    popuplib.send('teleport_menu', userid)

def teleport_menu_select(userid, choice, popupid):
  global dict_teleport
  user = int(userid)
  if choice == '1':
    target_list = popuplib.construct('target_list', 'players', '#alive', target_list_select)
    target_list.settitle("Select a Player:")
    popuplib.send('target_list', userid)
  elif choice == '2':
    target_list2 = popuplib.construct('target_list2', 'players', '#alive', target_list2_select)
    target_list2.settitle("Select a Player:")
    popuplib.send('target_list2', userid)
  elif choice == '3':
    dict_teleport[user]["loc"] = es.getplayerlocation(user)
    x,y,z = dict_teleport[user]["loc"]
    es.tell(userid, 'Teleport: Current Location Saved!')
  elif choice == '4':
    x,y,z = dict_teleport[user]["loc"]
    es.server.queuecmd('es_setpos %s %s %s %s'%(int(userid), x,y,z))
    es.tell(userid, 'Teleport: Teleported to Saved Location!')
  elif choice == '5':
    target_list3 = popuplib.construct('target_list3', 'players', '#alive', target_list3_select)
    target_list3.settitle("Select a Player:")
    popuplib.send('target_list3', user)
  elif choice == '6':
    target_list4 = popuplib.construct('target_list4', 'players', '#alive', target_list4_select)
    target_list4.settitle("Player To Teleport To:")
    popuplib.send('target_list4', user)

def target_list_select(userid, choice, popupid):
  x,y,z = es.getplayerlocation(choice)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(userid), x,y,z))
  playerlib.getPlayer(int(userid)).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  es.tell(int(choice), 'Teleport: %s was teleported to you!'%es.getplayername(int(userid)))
  es.tell(int(userid), 'Teleport: You teleported to %s!'%es.getplayername(int(choice)))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list')

def target_list2_select(userid, choice, popupid):
  x,y,z = es.getplayerlocation(userid)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(choice), x,y,z))
  playerlib.getPlayer(int(userid)).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  es.tell(int(choice), 'Teleport: You were teleported to and by %s!'%es.getplayername(int(userid)))
  es.tell(int(userid), 'Teleport: %s teleported to you!'%es.getplayername(int(choice)))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list2')

def target_list3_select(userid, choice, popupid):
  user = int(userid)
  x,y,z = dict_teleport[user]["loc"]
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(choice), x,y,z))
  es.tell(int(choice), 'Teleport: You have been teleported by %s!'%es.getplayername(user))
  es.tell(user, 'Teleport: You have teleported %s to Saved Location!'%es.getplayername(int(choice)))
  popuplib.delete('target_list3')

def target_list4_select(userid, choice, popupid):
  user = int(choice)
  target = int(choice)
  target_list5 = popuplib.easymenu('target_list5', '_popup_choice', target_list5_select)
  target_list5.settitle("Player To Teleport:")
  for player in playerlib.getUseridList('#alive'):
    target_list5.addoption((target,int(player)),es.getplayername(player))
  target_list5.send(userid)
  popuplib.delete('target_list4')

def target_list5_select(userid, choice, popupid):
  user, choice = choice
  dict_teleport[user]["spot"] = es.getplayerlocation(user)
  x,y,z = dict_teleport[user]["spot"]
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(choice), x,y,z))
  playerlib.getPlayer(user).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  gamethread.delayed(5, unblock_player2, (user, choice))
  popuplib.delete('target_list5')

def unblock_player(userid, choice):
  playerlib.getPlayer(int(choice)).set('noblock','0')
  playerlib.getPlayer(int(userid)).set('noblock','0')

def unblock_player2(user, choice):
  playerlib.getPlayer(int(user)).set('noblock','0')
  playerlib.getPlayer(int(choice)).set('noblock','0')

def player_activate(ev):
  user = int(ev['userid'])
  if ev['es_steamid'] in admin_list:
    if user not in dict_teleport:
      dict_teleport[user] = {}
      dict_teleport[user]["loc"] = 0
      dict_teleport[user]["spot"] = 0
  else:
    if user not in dict_teleport:
      dict_teleport[user] = {}
      dict_teleport[user]["spot"] = 0

def player_disconnect(ev):
  user = int(ev['userid'])
  if user in dict_teleport:
    del dict_teleport[user]

def unload():
  if es.exists('saycommand', '!teleport'):
    es.unregsaycmd('!teleport')